	.global msqrtasm

/*
eax = R1
ebx = R2
ecx = R3
*/

/*
	x86->ARM
	jl = blt
	jnz = bne
	shr = mov d, s, LSR#a - where d = destination register, s = source (value to shift) and a = shift amount
	sbb = sbc
*/

msqrtasm:	
	mov R3, R0			/*push parameter 1 into R3? (c in original asm below)*/
	mov R1, #0x40000000
	mov R2, #0x20000000
begit:
	cmp R3, R1
	blt skip
	sub R3, R3, R1
	add R1, R1, R2, LSL#2
skip:
	sub R1, R1, R2
	mov R1, R1, LSR#1
	mov R2, R2, LSR#2
	bne begit
	cmp R3, R1
	sbc R1, R1, #-1
	mov R1, R1, LSR#1
	mov R0, R1			/*push return value into r2? lower asm pop's ebx so i presume thats the return value*/

/*  end msqrtasm */

/* original msvc inline: 

static inline long msqrtasm(long c)
{
	_asm {
		push ebx
		mov ecx, c
		mov eax, 0x40000000
		mov ebx, 0x20000000
	begit:
		cmp ecx, eax
		jl skip
		sub ecx, eax
		lea eax, [eax+ebx*4]
	skip:
		sub eax, ebx
		shr eax, 1
		shr ebx, 2
		jnz begit
		cmp ecx, eax
		sbb eax, -1
		shr eax, 1
		pop ebx
	}
}

*/